wibble::Morph< Self, W, Interface > Struct Template Reference

`#include <amorph.h>`

Inheritance diagram for wibble::Morph< Self, W, Interface >:
[legend]
Collaboration diagram for wibble::Morph< Self, W, Interface >:
[legend]

## Public Types

typedef W | Wrapped

## Public Member Functions

| Morph (const Wrapped &w)
const Self & | self () const
bool | operator<= (const Morph &o) const
virtual bool | leq (const MorphInterface< Interface > *_o) const
virtual MorphInterface< Interface > * | constructCopy (void *where, unsigned int available) const
virtual void | destroy (unsigned int available)
const Wrapped & | wrapped () const
Wrapped & | wrapped ()
virtual | ~Morph ()
Public Member Functions inherited from wibble::MorphBase< W, Interface >
| MorphBase (const W &w)
template<typename _W >
EnableIf< IsPolymorphic< _W >, VirtualBase * >::T | virtualBase ()
template<typename _W >
EnableIf< TNot< IsPolymorphic< _W > >, VirtualBase * >::T | virtualBase ()
virtual VirtualBase * | virtualBase ()
W & | wrapped ()
Public Member Functions inherited from wibble::MorphInterface< Interface >
virtual | ~MorphInterface ()
Public Member Functions inherited from wibble::mixin::Comparable< Morph< Self, W, Interface > >
const Morph< Self, W, Interface > & | cmpSelf () const
bool | operator!= (const Morph< Self, W, Interface > &o) const
bool | operator== (const Morph< Self, W, Interface > &o) const
bool | operator< (const Morph< Self, W, Interface > &o) const
bool | operator> (const Morph< Self, W, Interface > &o) const
bool | operator>= (const Morph< Self, W, Interface > &o) const
Public Member Functions inherited from wibble::MorphAllocator
void * | operator new (size_t bytes, void *where, unsigned available)
void * | operator new (size_t bytes)

## Additional Inherited Members

Protected Attributes inherited from wibble::MorphBase< W, Interface >
W | m_wrapped

## Member Typedef Documentation

template<typename Self, typename W, typename Interface>

typedef W wibble::Morph< Self, W, Interface >::Wrapped

## Constructor & Destructor Documentation

template<typename Self, typename W, typename Interface>

wibble::Morph< Self, W, Interface >::Morph | ( | const Wrapped & | w | ) |

inline

template<typename Self, typename W, typename Interface>

virtual wibble::Morph< Self, W, Interface >::~Morph | ( |  | ) |

inline virtual

Referenced by wibble::Morph< IteratorMorph< T, W >, W, IteratorInterface< T > >::destroy().

## Member Function Documentation

template<typename Self, typename W, typename Interface>

virtual MorphInterface< Interface >* wibble::Morph< Self, W, Interface >::constructCopy | ( | void * | where,
|  | unsigned int | available
| ) |  | const

inline virtual

Implements wibble::MorphInterface< Interface >.

template<typename Self, typename W, typename Interface>

virtual void wibble::Morph< Self, W, Interface >::destroy | ( | unsigned int | available | ) |

inline virtual

Implements wibble::MorphInterface< Interface >.

template<typename Self, typename W, typename Interface>

virtual bool wibble::Morph< Self, W, Interface >::leq | ( | const MorphInterface< Interface > * | _o | ) | const

inline virtual

Implements wibble::MorphInterface< Interface >.

template<typename Self, typename W, typename Interface>

bool wibble::Morph< Self, W, Interface >::operator<= | ( | const Morph< Self, W, Interface > & | o | ) | const

inline

template<typename Self, typename W, typename Interface>

const Self& wibble::Morph< Self, W, Interface >::self | ( |  | ) | const

inline

template<typename Self, typename W, typename Interface>

const Wrapped& wibble::Morph< Self, W, Interface >::wrapped | ( |  | ) | const

inline

Referenced by wibble::Morph< IteratorMorph< T, W >, W, IteratorInterface< T > >::leq(), and wibble::Morph< IteratorMorph< T, W >, W, IteratorInterface< T > >::operator<=().

template<typename Self, typename W, typename Interface>

Wrapped& wibble::Morph< Self, W, Interface >::wrapped | ( |  | ) |

inline

The documentation for this struct was generated from the following file:

- amorph.h